/**
 * SO, 2010, Laborator 4
 * Alocare simpla de memorie 
 * Task 1 - linux 
 */

#include <stdio.h>
#include <stdlib.h>
#define	MAX		100
#define CHUNK		10
#define SEED		23
#define STOP		17


int main(void){

	int nr, count = 0;
	int *buffer;

	
	/* TODO - alocare buffer cu dimensiune CHUNK */
	buffer = (int*) malloc ( CHUNK * sizeof(int) );

	if (buffer == NULL) {
		perror("malloc");
		exit(-1);
	}
	
	srand(SEED);
	do {
		nr = 1 + rand()%MAX;

		buffer[count] = nr;

		count++;

		if (count % CHUNK == 0) {
			printf("Realloc\n");

			/* TODO  - redimensionarea bufferului pentru inca CHUNK elemente */
			buffer = (int*) realloc (buffer, (count + CHUNK) * sizeof(int));
			
			if (buffer == NULL){
				perror("realloc");
				exit(-1);
			}
		}

		printf("Nr %d - val %d\n", count, buffer[count-1]);

	} while ( buffer[count-1] != STOP);

	/* TODO - eliberare memorie */
	free(buffer);

	return 0;
}
