/**
 * SO , 2010 - Laborator 4
 * malloc wrappers
 * Task 1 - windows
 */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

void *xmalloc(size_t size)
{
        HANDLE heap;
        void *ptr;

        heap = GetProcessHeap();
        if (heap == NULL) {
                fprintf(stderr, "GetProcessHeap: error %ld\n", GetLastError());
                ExitProcess(1);
        }

        ptr = HeapAlloc(
                        heap,
                        0,
                        size);
        if (ptr == NULL) {
                fprintf(stderr, "GetProcessHeap: error %ld\n", GetLastError());
                abort();
        }

        return ptr;
}

